'GPS-Daten-Anzeige
'Verfasser DB1OV
'02.12.2006   Version vom 22.12.2007
'ATMEGA8
'Quarz 10,752000 MHz
'Port B.0 = Error-Anzeige
'Port B.1 = OK-Anzeige
'LCD HD44780  (2 x 20)

$regfile = "m8def.dat"
$crystal = 10752000
$baud = 4800
$hwstack = 32
$swstack = 10
$framesize = 40

Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portb.1 , Rs = Portb.0
Config Lcd = 20 * 2
Cls
Cursor Off

Dim M_fix As String * 6
Dim My_sw As String * 2
Dim My_z As Byte
Dim My_time As String * 6
Dim My_time_a As String * 2
Dim My_time_ab As Byte
Dim My_b As String * 10
Dim My_l As String * 11
Dim My_b_anz As String * 11
Dim My_l_anz As String * 11
Dim My_time_anz As String * 6
Dim My_date_anz As String * 6
Dim Av As String * 11
Dim Ns As String * 2
Dim Leng As Byte
Dim Mrk As String * 2
Dim My_date As String * 6
Dim My_tt As String * 2
Dim My_mon As Byte
Dim Xx As Bit
Dim My_sat As String * 2
Dim Bb_1 As String * 2
Dim Bb_2 As String * 2
Dim Vbb_1 As Integer
Dim Vbb_2 As Integer
Dim Ll_1 As String * 3
Dim Ll_2 As String * 2
Dim Vll_1 As Integer
Dim Vll_2 As Integer
Dim M_meter As String * 6
Dim M_m As String * 2
Dim M_sek As Byte
Dim M_sek_str As String * 2
Dim M_instr As Byte
Dim M_nord As String * 2
Dim M_ost As String * 2
Dim M_nord_n As String * 1
Dim M_ost_o As String * 1
Dim L As Integer
Dim L_1 As Single
Dim L_11 As Integer
Dim B As Integer
Dim B_1 As Single
Dim B_11 As Integer
Dim Bu1 As Single
Dim Bu2 As Single
Dim Bu1a As Byte
Dim Bu2a As Byte
Dim Zi1 As Single
Dim Zi2 As Single
Dim Zi1a As Byte
Dim Zi2a As Byte
Dim Bu3 As Single
Dim Bu4 As Single
Dim Bu3a As Byte
Dim Bu4a As Byte
Dim L_2 As Integer
Dim B_2 As Integer
Dim Yy As Single
Dim M_tag As String * 2
Dim M_monat As String * 2
Dim M_jahr As String * 2
M_fix = "DB1OV"
Declare Sub Wait_jupiterstring(byval M_str As String)
Declare Function Read_jupiterstring() As String
Config Portc.0 = Output
Config Portc.1 = Output
Config Portc.2 = Input
Config Portc.3 = Input
Set Portc.0
Set Portc.1
Set Portc.2
Set Portc.3
Portc.0 = 1
Portc.1 = 0
Portc.2 = 1
Portc.3 = 1
Config Serialin = Buffered , Size = 20
Enable Interrupts
' $GPRMC,hhmmss,A,llll.ll,a,yyyyy.yy,a,x.x,x.x,ddmmyy,x.x,a*hh
' $GPGGA,hhmmss,Breite,Lnge,Messung,SatAnzahl,.....
Cls
If Pinc.2 = 1 Then
  Locate 1 , 2
  Lcd "GPS-Daten-Anzeige"
  Locate 2 , 8
  Lcd M_fix
End If
If Pinc.2 = 0 Then
  Locate 1 , 1
  Lcd "GPS-Datenanzeige"
  Locate 2 , 6
  Lcd "DB1OV"
End If
Wait 4
My_z = 1
Mrk = "-"
Av = ""
If Mid(m_fix , 3 , 1) = Chr(49) Then Else My_z = 0.1
If Mid(m_fix , 1 , 1) = Chr(68) Then Else My_z = 0.2
If Mid(m_fix , 4 , 1) = Chr(79) Then Else My_z = 0.3
If Mid(m_fix , 2 , 1) = Chr(66) Then Else My_z = 0.4
Cls
M_meter = ""
M_fix = ""

Do
  If My_z = 1 Then
    Call Wait_jupiterstring( "$GPGGA,")
    My_time = Read_jupiterstring()
    My_time_anz = Left(my_time , 6)
    My_b = Read_jupiterstring()
    M_nord = Read_jupiterstring()
    M_nord = Left(m_nord , 1)
    My_l = Read_jupiterstring()
    M_ost = Read_jupiterstring()
    M_ost = Left(m_ost , 1)
    Ns = Read_jupiterstring()
    My_sat = Read_jupiterstring()
    Leng = Len(my_sat) - 1
    My_sat = Left(my_sat , Leng)
    Ns = Read_jupiterstring()
    M_meter = ""
    M_meter = Read_jupiterstring()
    M_m = ""
    M_m = Read_jupiterstring()
    My_tt = Mid(my_date , 3 , 2)
    My_mon = Val(my_tt)
    If My_mon >= 4 And My_mon <= 10 Then
      My_sw = "s"
      My_time_a = Mid(my_time , 1 , 2)
      My_time_ab = Val(my_time_a)
      My_time_ab = My_time_ab + 2
      My_time_a = Str(my_time_ab)
    Else
      My_sw = "w"
      My_time_a = Mid(my_time , 1 , 2)
      My_time_ab = Val(my_time_a)
      My_time_ab = My_time_ab + 1
      My_time_a = Str(my_time_ab)
    End If
    If My_time_ab = 24 Then
      My_time_a = "0"
    End If
    If My_time_ab = 25 Then
      My_time_a = "1"
    End If
    If Len(my_time_a) = 1 Then
      My_time_a = "0" + My_time_a
    End If
    If Pinc.2 = 1 And Pinc.3 = 1 And My_z = 1 Then
      Locate 1 , 1
      Lcd My_time_a ; ":" ; Mid(my_time , 3 , 2) ; ":" ; Mid(my_time , 5 , 2) ; " "
    End If
    If Pinc.2 = 0 And Pinc.3 = 1 Then
      Locate 1 , 1
      Lcd My_time_a ; ":" ; Mid(my_time , 3 , 2) ; " "
    End If
    Leng = Len(my_b) - 1
    My_b = Left(my_b , Leng)
    My_b_anz = My_b
    My_b = Mid(my_b , 1 , 4)
    Bb_1 = Mid(my_b , 1 , 2)
    Bb_2 = Mid(my_b , 3 , 2)
    Vbb_1 = Val(bb_1)
    Vbb_2 = Val(bb_2)
    If M_nord = "S" Or M_nord = "s" Then
      Vll_1 = Vbb_1 * 2
      Vbb_1 = Vbb_1 - Vll_1
    End If
    B = Vbb_1 + 90
    B = B * 60
    B = B + Vbb_2
    Leng = Len(my_l)
    My_l = Left(my_l , Leng)
    My_l_anz = My_l
    My_l = Mid(my_l , 1 , 5)
    Ll_1 = Mid(my_l , 1 , 3)
    Ll_2 = Mid(my_l , 4 , 2)
    Vll_1 = Val(ll_1)
    Vll_2 = Val(ll_2)
    If M_ost = "W" Or M_ost = "w" Then
      Vbb_1 = Vll_1 * 2
      Vll_1 = Vll_1 - Vbb_1
    End If
    L = Vll_1 + 180
    L = L * 60
    L = L + Vll_2
    Bu1 = L / 1200
    Bu1 = Int(bu1)
    L_11 = Int(bu1)
    Bu1 = Bu1 + 1
    Bu1a = Bu1 + 64
    L_1 = 1200 * L_11
    L_1 = Int(l_1)
    L_1 = L - L_1
    Bu2 = B / 600
    Bu2 = Int(bu2)
    B_11 = Int(bu2)
    Bu2 = Bu2 + 1
    Bu2a = Bu2 + 64
    B_1 = 600 * B_11
    B_1 = Int(b_1)
    B_1 = B - B_1
    Zi1 = L_1 / 120
    Zi1 = Int(zi1)
    Zi1a = Zi1
    L_2 = Zi1 * 120
    L_2 = L_1 - L_2
    Zi2 = B_1 / 60
    Zi2 = Int(zi2)
    Zi2a = Zi2
    B_2 = Zi2 * 60
    B_2 = B_1 - B_2
    Bu3 = L_2 / 5
    Bu3 = Int(bu3)
    Bu3 = Bu3 + 1
    Bu3a = Bu3 + 64
    Yy = 5
    Yy = Yy / 2
    Bu4 = B_2 / Yy
    Bu4 = Int(bu4)
    Bu4 = Bu4 + 1
    Bu4a = Bu4 + 64
    My_z = 2
  End If
  If My_z = 2 Then
    Call Wait_jupiterstring( "$GPGSA,")
    Ns = Read_jupiterstring()
    M_fix = Read_jupiterstring()
    M_fix = Left(m_fix , 1)
    If M_fix = "1" Then M_fix = "0-Fix "
    If M_fix = "2" Then M_fix = "2D-Fix"
    If M_fix = "3" Then M_fix = "3D-Fix"
    If Pinc.3 = 1 And M_sek >= 20 And M_sek <= 39 And Len(m_fix) > 4 Then
       Locate 2 , 1
       Lcd "SA: " ; M_fix ; " "
    End If
    My_z = 3
  End If
  If My_z = 3 Then
    Call Wait_jupiterstring( "$GPRMC,")
    Ns = Read_jupiterstring()
    Av = Read_jupiterstring()
    Ns = Read_jupiterstring()
    Ns = Read_jupiterstring()
    Ns = Read_jupiterstring()
    Ns = Read_jupiterstring()
    Ns = Read_jupiterstring()
    Ns = Read_jupiterstring()
    My_date = Read_jupiterstring()
    Leng = Len(my_date) - 1
    My_date = Left(my_date , Leng)
    My_date_anz = My_date
    M_tag = Mid(my_date , 1 , 2)
    M_monat = Mid(my_date , 3 , 2)
    M_jahr = Mid(my_date , 5 , 2)
    If Av = "V," Then
      Av = "*ERROR*    "
      Toggle Portc.0
      Portc.1 = 0
    End If
    If Av = "A," Then
      Av = ""
      Portc.0 = 0
      Portc.1 = 1
    End If
    If Pinc.3 = 1 Then
      Locate 2 , 1
      Lcd Av
      Waitms 10
    End If
    If Pinc.2 = 1 And Pinc.3 = 1 Then
      Locate 1 , 12
      Lcd " " ; M_tag ; "." ; M_monat ; "." ; M_jahr ; "     "
      Waitms 10
    End If
    If Pinc.2 = 0 And Pinc.3 = 1 Then
      Locate 1 , 8
      Lcd " " ; M_tag ; "." ; M_monat ; "." ; M_jahr ; "     "
      Waitms 10
    End If
    My_z = 1
  End If
  If Xx = 1 Then Mrk = " "
  If Xx = 0 Then Mrk = My_sw
  Toggle Xx
  If Pinc.2 = 1 And Pinc.3 = 1 Then
    Locate 1 , 10
    Lcd Mrk ; " "
    Waitms 5
  End If
  If Pinc.2 = 0 And Pinc.3 = 1 Then
    Locate 1 , 7
    Lcd Mrk ; " "
    Waitms 5
  End If
  If Pinc.3 = 0 Then
    If M_nord = "N" Then M_nord_n = "n"
    If M_nord = "S" Then M_nord_n = "s"
    If M_ost = "E" Then M_ost_o = "o"
    If M_ost = "W" Then M_ost_o = "w"
    Locate 1 , 1
    Lcd M_nord_n ; "B " ; My_b_anz ; " " ; Mid(my_time_anz , 1 , 2) ; "." ; Mid(my_time_anz , 3 , 2) ; "." ; Mid(my_time_anz , 5 , 2) ; " UTC    "
    Waitms 50
    Locate 2 , 1
    Lcd M_ost_o ; "L " ; My_l_anz ; " " ; Mid(my_date_anz , 1 , 2) ; "." ; Mid(my_date_anz , 3 , 2) ; "." ; Mid(my_date_anz , 5 , 2) ; "    "
    If Pinc.1 = 0 Then
      Locate 1 , 1
      Lcd "Schlechter Empfang! "
      Waitms 100
      Locate 2 , 1
      Lcd "RX  not  ok !       "
      Waitms 100
    End If
  End If
  If Pinc.2 = 1 And Pinc.3 = 1 Then
    Locate 2 , 12
    Lcd " TX = " ; My_sat ; "      "
    Waitms 10
  End If
  If Pinc.2 = 0 And Pinc.3 = 1 Then
    Locate 2 , 11
    Lcd " TX=" ; My_sat ; "      "
    Waitms 10
  End If
  If Pinc.3 = 1 Then
    Lowerline
    M_instr = 0
    M_instr = Instr(m_meter , ".")
    M_instr = M_instr - 1
    M_sek_str = Mid(my_time , 5 , 2)
    M_sek = Val(m_sek_str)
    If M_sek >= 0 And M_sek <= 19 And Len(my_b_anz) > 4 Then
      Locate 2 , 1
      Lcd "QTH " ; Chr(bu1a) ; Chr(bu2a) ; Zi1a ; Zi2a ; Chr(bu3a) ; Chr(bu4a) ; " "
      Waitms 10
    End If
    If M_sek >= 40 And M_sek <= 59 And M_instr > 1 Then
      M_meter = Left(m_meter , M_instr)
      M_meter = Left(m_meter , 4)
      Locate 2 , 8
      Lcd "   "
      Locate 2 , 1
      Lcd "ueNN " ; M_meter ; Left(m_m , 1)
      Waitms 10
    End If
  End If
Loop
End

Sub Wait_jupiterstring(byval M_str As String) As String
  Local M_zi As Byte
  Local M_wk As Byte
  M_zi = 1
  M_wk = ""
M1:
  M_wk = Waitkey()
  If M_wk <> Mid(m_str , M_zi , 1) Then
    Goto M1
  Else
    Incr M_zi
    If M_zi > Len(m_str) Then Goto M2
    Goto M1
  End If
M2:
End Sub

Function Read_jupiterstring() As String
  Local M_byte As Byte
  Local M_word As String * 10
  M_word = ""
  M_byte = ""
  Do
    M_byte = Waitkey()
    M_word = M_word + Chr(m_byte)
  Loop Until M_byte = ","
  Read_jupiterstring = Left(m_word , 10)
End Function

End
Return
